"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _unistUtilVisit = _interopRequireDefault(require("unist-util-visit"));

var _shiki = require("shiki");

var _renderer = require("./renderer");

var _default = async ({
  markdownAST
}, {
  theme = "nord",
  classPrefix = "language-"
}) => {
  const highlighter = await (0, _shiki.getHighlighter)({
    theme
  });
  (0, _unistUtilVisit.default)(markdownAST, `code`, node => {
    node.type = "html";
    node.children = undefined;
    const token = highlighter.codeToThemedTokens(node.value, node.lang, theme, {
      includeExplanation: true
    });

    if (!node.lang) {
      node.value = `<pre class="${classPrefix}unknown"><code>${node.value}</code></pre>`;
    }

    const _theme = highlighter.getTheme(theme);

    node.value = (0, _renderer.renderToHtml)(token, {
      langId: node.lang,
      fg: _theme.fg,
      bg: _theme.bg
    });
  });
};

exports.default = _default;